!ifndef RELEASE
# Put 0 if you want debug information
RELEASE = 1
!endif

!include make.lnk

# Default PATH = current path
!ifndef HPPPATH
HPPPATH = $(CPPPATH)
!endif
!ifndef RESPATH
RESPATH = $(CPPPATH)
!endif
!ifndef LIBRARYPATH
LIBRARYPATH = $(CPPPATH)
!endif

!ifdef RES
!ifdef RESDLLS
RES_PRESENT = 0
!else
RES_PRESENT = 1
!endif
!else
RES_PRESENT = 0
!endif


!ifdef LIBNAME
LIB_PRESENT = 1
!else
LIB_PRESENT = 0
!endif

# Put all your dependencies in file Make.dep
# And don't worry about the rest contents of this file
#

!if $(RTSS)
!if $(LIB_PRESENT)
EXT = .lib
DCF = 
DLF = -nodefaultlib -subsystem:native,4.00 
!else
EXT = .rtss
DCF = 
DLF = -INCREMENTAL:NO -FULLBUILD -driver -nodefaultlib -base:0x10000\
  -align:0x20 -subsystem:native,4.00 /PDB:NONE -entry:_RtapiProcessEntryCRT@8
!endif
!else
!if $(LIB_PRESENT)
EXT = .dll
DCF = /LD /GD /MD 
DLF = /DLL
!else
EXT = .exe
DCF = /GA /ML
DLF = 
!endif
!endif

!if $(RELEASE)
# Put Compiler and linker options for Realease version here
CF = $(CG) $(CR) $(DCF)
LF = $(LG) $(LR) $(DLF)
!else
# Put Compiler and linker options for Debug version here
CF = $(CG) $(CD) $(DCF)
LF = $(LG) $(LD) $(DLF)
!endif

.all: \
!ifdef RESDLLS
   $(RESDLLS) \
!endif
!ifdef MSGFILES
   $(MSGFILES) \
!endif
!if $(RES_PRESENT)
   $(RESPATH)$(RES).res \
!endif
   $(OBJS) \
   $(EXEPATH)$(EXE)$(EXT) \

LIB = $(LIBRARYPATH);$(LIB)
INCLUDE = $(HPPPATH);$(INCLUDE)

!IF "$(OS)" == "Windows_NT"
NULL=
!ELSE 
NULL=nul
!ENDIF 


"$(EXEPATH)" :
    if not exist "$(EXEPATH)/$(NULL)" mkdir "$(EXEPATH)"

"$(OBJPATH)" :
    if not exist "$(OBJPATH)/$(NULL)" mkdir "$(OBJPATH)"

.SUFFIXES:
.SUFFIXES: .cpp .cxx .obj .msg .txt .dll .exe .res .rc .pc .lib .def .de_ .asm .c .dir .rtss

{$(CPPPATH)}.cpp{$(OBJPATH)}.obj:
      @echo MAKE: COMPILING $** TO $@
      @cl $(CF) /c /Fo$@ $**

{$(CPPPATH)}.cxx{$(OBJPATH)}.obj:
      @echo MAKE: COMPILING $** TO $@
      @cl $(CG) $(CR) /c /Fo$@ $**

{$(CPATH)}.c{$(OBJPATH)}.obj:
      @echo MAKE: COMPILING $** TO $@
      @cl $(CF) /c /Fo$@ $**

{$(ASMPATH)}.asm{$(OBJPATH)}.obj:
      @echo MAKE: COMPILING ASSEMBLER $** TO $@
      @ml /c /Fo$@ $**

{$(TXTPATH)}.txt{$(MSGPATH)}.msg:
      @echo MAKE: COMPILING MESSAGES: $** TO $@
      @mkmsgf $** $@

{$(RCPATH)}.def{$(EXEPATH)}.dll:
      @echo MAKE: COMPILING RESOURCES TO $(@B).res
      - @copy $(RCPATH)$(@B)\. $(RCPATH) >nul
!ifdef RETPATH
      @cd $(RCPATH:^\= )
      @rc.exe $(RF) /i $(RETPATH)$(RCINCLUDE) -r $(RES).rc \
              $(RETPATH)$(RESPATH)$(@B).res
      @cd $(RETPATH:^\= )
!else
      @rc.exe $(RF) -r $(RCPATH)$(RES).rc $(RESPATH)$(@B).res
!endif
      @echo MAKE: LINKING RESOURCE DLL: $@
      @icc  $(CG) $(CR) /Ge- /Fe$@ /Fo$(RESPATH) /B"$(LG) $(LF) /DLL" \
            $(RCPATH)resdll.cpp $(RCPATH)$(*B).def
      @echo MAKE: BINDING RESOURCES $(RESPATH)$(@B).res TO $@
      @rc.exe $(RF)  -fo$@ $(RESPATH)$(@B).res > NUL


$(RESPATH)$(RES).res: $(RCPATH)$(RES).rc
      @echo MAKE: COMPILING RESOURCES $** TO $@
!ifdef RETPATH
      @cd $(RCPATH:^\= )
      @rc.exe $(RF) /i $(RETPATH)$(RCINCLUDE) -fo$(RETPATH)$@ $(RETPATH)$**
      @cd $(RETPATH:^\= )
!else
      @rc.exe $(RF) -fo$@ $** 
!endif

$(EXEPATH)$(EXE)$(EXT): \
!if $(RES_PRESENT)
    $(RESPATH)$(RES).res \
!endif
    $(OBJS)
     @echo MAKE: LINKING $@
     @link.exe @<<
 $(LF)
 /OUT:$@
!if $(RES_PRESENT)
    $(RESPATH)$(RES).res
!endif
 $(OBJS)
 $(LIBS)
<<

!include make.dep