//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _AB1784CARD_INL
#define _AB1784CARD_INL

#ifndef _BTRACE_
   #include "btrace.hpp"
#endif


//-----------------------------------------------------------------------------
inline unsigned AB1784Card::baseMemoryAddress () const
{
BFUNCTRACE_ALL ();

return theBaseMemoryAddress;
} // end AB1784Card::baseMemoryAddress () const


//-----------------------------------------------------------------------------
inline unsigned AB1784Card::linkSpeed () const
{
BFUNCTRACE_ALL ();

return theLinkSpeed;
} // end AB1784Card::linkSpeed () const


//-----------------------------------------------------------------------------
inline unsigned char AB1784Card::getCurrentTransaction ()
{
BFUNCTRACE_ALL ();

return ++theCurrentTransaction;
} // end AB1784Card::getCurrentTransaction ()


//-----------------------------------------------------------------------------
inline const char * const AB1784Card::firmwarePath () const
{
BFUNCTRACE_ALL ();

return theFirmwarePath.data();
} // end AB1784Card::firmwarePath () const

#endif
