//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _FWFBUFF_
#define _FWFBUFF_

#ifndef _UNIIO_H
   #include "uniio.h"
#endif


//-----------------------------------------------------------------------------
namespace Uniio
{

class _Export_UNIIO FirmwareFileBuffer
{
public :

   FirmwareFileBuffer ( const char * const inFileName );
   ~FirmwareFileBuffer ();

   unsigned long size () const { return theFileSize; }
   operator char* () {return theBuffer; }

protected :

private :

   FirmwareFileBuffer (const FirmwareFileBuffer & );
   FirmwareFileBuffer operator = (const FirmwareFileBuffer &);

   unsigned long theFileSize;
   char * theBuffer;

}; // end FirmwareFileBuffer class declaration
}; // end namespace

#endif
