//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _PCIDEV_INL
#define _PCIDEV_INL

#ifndef _BTRACE_
   #include "btrace.hpp"
#endif

//-----------------------------------------------------------------------------
inline unsigned short PCIDeviceInfo::vendorId () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> VendorID;
} // end 

//-----------------------------------------------------------------------------
inline unsigned short PCIDeviceInfo::deviceId () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> DeviceID;
} // end 

//-----------------------------------------------------------------------------
inline unsigned short PCIDeviceInfo::status () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Status;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::revisionId () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> RevisionID;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::progIf () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> ProgIf;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::subClass () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> SubClass;
} // end

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::baseClass () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> BaseClass;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::cacheLineSize () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> CacheLineSize;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::latencyTimer () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> LatencyTimer;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::headerType () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> HeaderType;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::BIST () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> BIST;
} // end 

//-----------------------------------------------------------------------------
inline unsigned long PCIDeviceInfo::baseAddress (const unsigned char i) const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.BaseAddresses[i];
} // end 

//-----------------------------------------------------------------------------
inline unsigned long PCIDeviceInfo::CIS () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.CIS;
} // end 

//-----------------------------------------------------------------------------
inline unsigned short PCIDeviceInfo::subVendorId () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.SubVendorID;
} // end 

//-----------------------------------------------------------------------------
inline unsigned short PCIDeviceInfo::subSystemId () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.SubSystemID;
} // end 

//-----------------------------------------------------------------------------
inline unsigned long PCIDeviceInfo::ROMBaseAddress () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.ROMBaseAddress;
} // end 


//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::capabilityList () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.CapabilityList;
} // end 


//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::interruptLine () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.InterruptLine;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::interruptPin () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.InterruptPin;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::minimumGrant () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.MinimumGrant;
} // end 

//-----------------------------------------------------------------------------
inline unsigned char PCIDeviceInfo::maximumLatency () const
{
BFUNCTRACE_ALL ();

return thePCIConfig -> Header.Type0.MaximumLatency;
} // end 


#endif