//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _PCICFG1_
#define _PCICFG1_

#ifndef _PCICFGDR_
   #include "pcicfgdr.hpp"
#endif

#ifndef _IOPORT_
   #include "ioport.hpp"
#endif

//-----------------------------------------------------------------------------
namespace Uniio
{

class PCIConfig1 : public PCIConfigDirect
{
public:

   PCIConfig1 ();
   virtual ~PCIConfig1 ();

   virtual bool exists () const;

protected:

   virtual unsigned char readChar ( const unsigned char inBus
                               , const unsigned char inSlot
                               , const unsigned char inOffset
                               ) const;

   virtual unsigned short readShort ( const unsigned char inBus
                               , const unsigned char inSlot
                               , const unsigned char inOffset
                               ) const;

   virtual unsigned long readLong ( const unsigned char inBus
                                , const unsigned char inSlot
                                , const unsigned char inOffset
                                ) const;

   virtual void write ( const unsigned char inBus
                            , const unsigned char inSlot
                            , const unsigned char inOffset
                            , const unsigned char inValue
                            );

   virtual void write ( const unsigned char inBus
                            , const unsigned char inSlot
                            , const unsigned char inOffset
                            , const unsigned short inValue
                            );

   virtual void write ( const unsigned char inBus
                            , const unsigned char inSlot
                            , const unsigned char inOffset
                            , const unsigned long inValue
                            );

private:

   // disable copy constructor and assignment operator
   PCIConfig1 (const PCIConfig1 & );
   PCIConfig1 & operator = (const PCIConfig1 &);

   mutable IOPort theCommandPort;

}; // end PCIConfig1 class declaration

}; // end namespace

#endif
