//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _BTRACE_
   #include "btrace.hpp"
#endif

#ifndef _PCICFGSL_
   #include "pcicfgsl.hpp"
#endif

#ifndef _PCICFG1_
   #include "pcicfg1.hpp"
#endif

#ifndef _PCICFG2_
   #include "pcicfg2.hpp"
#endif

#include <cstddef>

using namespace Uniio;

//-----------------------------------------------------------------------------
PCIConfigSelector::PCIConfigSelector ()
{
BFUNCTRACE_DEVELOP ();
} // end constructor


//-----------------------------------------------------------------------------
PCIConfigSelector::~PCIConfigSelector ()
{
BFUNCTRACE_DEVELOP ();
} // end destructor

//-----------------------------------------------------------------------------
PCIConfig * PCIConfigSelector::createPCIConfig()
{
BFUNCTRACE_DEVELOP ();
PCIConfig * aConfig = new PCIConfig1 ();
if (aConfig -> exists())
{
   return aConfig;
}
delete aConfig;
aConfig = new PCIConfig2 ();
if (aConfig -> exists())
{
   return aConfig;
}
delete aConfig;
return NULL;
} // end 
