//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _BTRACE_
   #include "btrace.hpp"
#endif

#ifndef _DUMMYCARD_
   #include "dummycard.hpp"
#endif

using namespace Uniio;

//-----------------------------------------------------------------------------
DummyCard::DummyCard ( )
  : IOCard ("DUMMY")
{
BFUNCTRACE_DEVELOP ();
}  // end constructor


//-----------------------------------------------------------------------------
DummyCard::~DummyCard ()
{
BFUNCTRACE_DEVELOP ();
} // end destructor


//-----------------------------------------------------------------------------
IOCard & DummyCard::updateInputs ( const IOTrack & inTrack
                                 , long * inImage
                                 , long & inTrackState
                                 )
{
BFUNCTRACE_DEVELOP ();

return * this;
} // end DummyCard::updateInputs (..)


//-----------------------------------------------------------------------------
IOCard & DummyCard::updateOutputs ( const IOTrack & inTrack
                                  , const long * const inImage
                                  , long & inTrackState
                                  )
{
BFUNCTRACE_DEVELOP ();
return * this;
} // end DummyCard::updateOutputs (..)


//-----------------------------------------------------------------------------
IOCard & DummyCard::addTrack ( IOTrack & inTrack )
{
BFUNCTRACE_DEVELOP ();
return * this;
} // end DummyCard::addTrack (..)
