/*
 * This software is in the public domain.
 * You may use it as you see fit with the understanding that
 * we make no guarantees of its fitness for any particular purpose.
 *
 * Author: XESS Corporation
 *         www.xess.com
 */

//
// Hex objects just store hexadecimal numbers with
// a set number of digits.
//

// $Log: hex.h $
// Revision 1.2  1999/03/30 18:27:41  DEVB
// Released source into the public domain
//
// Revision 1.1  1999/03/29 22:48:11  DEVB
// Initial revision
//

#ifndef Hex_H
#define Hex_H

#include <iostream.h>

class Hex
{
	public:

	/* begin Hex methods */

	/* method: Hex */
	// construct a hex number with a given number of hex digits
	 Hex(unsigned int l=4);

	/* method: SetLength */
	// set the number of hex digits in the hex number
	void SetLength(unsigned int l);

	/* method: GetLength */
	// return the number of hex digits in the hex number
	unsigned int GetLength(void);

	/* method: SetHex */
	// assign a value to the hex number
	void SetHex(unsigned int h);

	/* method: operator= */
	// assign a value to the hex number
	Hex& operator=(unsigned int h);

	/* method: GetHex */
	// return the value of the hex number
	unsigned int GetHex(void);

	private:

	unsigned int hex;	
	unsigned int length;

	/* end Hex methods */
};

/* begin Hex functions */

/* function: CharToHex */
// helper function to convert ASCII '0'-'F' to number between 0 and 15, inclusive
unsigned int CharToHex(char c);

// helper function which gets a hex number from an input stream
istream& operator>> (istream& is, Hex& n);

// helper function which outputs a hex number to an output stream
ostream& operator<< (ostream& os, Hex& n);

/* end Hex functions */

#endif
