/*
 * This software is in the public domain.
 * You may use it as you see fit with the understanding that
 * we make no guarantees of its fitness for any particular purpose.
 *
 * Author: XESS Corporation
 *         www.xess.com
 */

#ifndef progress_H
#define progress_H

#include "xserror.h"

#ifdef _WINDOWS
#include <afxwin.h>
#include <afxcmn.h>
#endif


#ifdef _WINDOWS
class Progress : public CWnd
#else
class Progress
#endif
{
	public:

	/* begin progress methods */

	/* method: progress */
	// create a progress indicator object
	Progress();

	/* method: progress */
	// create a progress indicator object
	Progress(XSError* e,	// error reporting channel
		string& maintaskDesc,	// what is progress reported about?
		string& subtaskDesc,	// what is the task being performed?
		float lo, float hi		// upper and lower bounds of progress
		);

	/* method: ~progress */
	// destroy a progress indicator object
	~Progress(void);

	/* method: Setup */
	// setup the progress indicator
	bool Progress::Setup(XSError* e, string& maintaskDesc, string& subtaskDesc, float lo, float hi);

	/* method: Report */
	// indicate the current progress between the upper and lower bounds
	void Report(float x);

	private:

	/* end progress methods */

	XSError* errorChannel;
	string maintaskDescription, subtaskDescription;
	float loBound, hiBound, percentDone;
	bool visible;	// is progress indicator visible or not

#ifdef _WINDOWS
	CProgressCtrl ctlProgress;
	CStatic description;
protected:
	afx_msg void OnPaint();
	DECLARE_MESSAGE_MAP()
#endif
};

/* begin progress functions */

/* end progress functions */

#endif
